//---------------------
#include <ASTCanLib.h>
//------------------------------------------------------------------------------------
st_cmd_t Msg; // CAN message object
//------------------------------------------------------------------------------------
volatile boolean CAN_Tx_GO_Flag = false;
volatile boolean CAN_Tx_OK_Flag = false;
volatile byte  Buffer[8]      = {0}; //Buffer for CAN data
volatile byte  CAN_RxD[15][9] = {0}; //RxD 15個 x ( Length + data8個) = 135byte
volatile byte  CAN_TxD[15][9] = {0}; //TxD 15個 x ( Length + data8個) = 135byte
volatile byte _CAN_TxD[9]     = {0}; //Length + data8個 一時バッファー
volatile byte  CTx_MOb_No[15] = {14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0};

//===============
//Rx => MOb00~07
//Tx => MOb14~08
//===============

//--- CAN Rx ID set ----------------------------
volatile const unsigned int CAN_Rx_ID_0[15] = {
  0x020,  0x030,  0,      0,
  0,      0,      0,      0,
  0,      0,      0,      0,
  0,      0,      0
};
//--- CAN Tx ID set ----------------------------
volatile const unsigned int CAN_Tx_ID_0[15] = {
  0x020,  0x030,  0,      0,
  0,      0,      0,      0,
  0,      0,      0,      0,
  0,      0,      0
};


//------------------------------------------------------------------------------
void CAN_SetUP_LOOP() {
  canInit(500000);          // Initialise CAN port. must be before Serial.begin
  Msg.pt_data = &Buffer[0]; // reference message data to buffer
  Msg.ctrl.ide = 0;         // Set CAN protocol (0: CAN 2.0A, 1: CAN 2.0B)
}

//--- CRx MOb 0-7 ---------------------------
void CAN_MOb_SET_000() {
  byte         MOb_No   = 0;
  unsigned int ID_No    = 0;
  unsigned int MASK_VAL = 0x07FF;
  //-----------------------------------------
  //ID & MASK set
  for (byte i = 0; i < 8; i++) {
    MOb_No    = i;
    ID_No     = CAN_Rx_ID_0[i];
    MASK_VAL  = 0x7FF;
    CAN_MOb_IDNO_SET_000(MOb_No, ID_No);
    CAN_MOb_MASK_SET_000(MOb_No, MASK_VAL);
  }
}

//--------------------------------------------------------
void CAN_MOb_IDNO_SET_000(byte _No, unsigned int _ID) {
  unsigned int MM = 0;
  byte L = 0;
  byte M = 0;
  //--- Page set -------------
  M = CANPAGE & B00001111;
  L = _No << 4;
  L = L & B11110000;
  M = M | L;
  CANPAGE = M ;
  //--- ID NO set ------------
  // STD ID only
  L  = _ID & B00000111;
  L  = L << 5;
  L  = L & B11100000;
  MM = _ID >> 3;
  M  = MM;
  CANIDT2 = L;
  CANIDT1 = M;
  //--- CANCDMOB set ---------------------
  CANCDMOB = B10000000;  //MOB を　Rxに設定
}

//--------------------------------------------------------
void CAN_MOb_MASK_SET_000(byte _No, unsigned int _MASK) {
  unsigned int MM = 0;
  byte L = 0;
  byte M = 0;
  //--- Page set ----------
  M = CANPAGE & B00001111;
  L = _No << 4;
  L = L & B11110000;
  M = M | L;
  CANPAGE = M ;
  //--- ID MASK set -------
  // STD ID only
  L  = _MASK & B00000111;
  L  = L << 5;
  L  = L & B11100000;
  MM = _MASK >> 3;
  M  = MM;
  CANIDM2 = L;
  CANIDM1 = M;
  //-- IDMASK Enable set --
  L = CANIDM4 & B11111110;
  CANIDM4 = L | B00000001;
}


//
