//--------------------------------
void CAN_Rx_loop_00_07MOb() {
  static  byte _I = 0;
  if (CAN_Rx_ID_0[_I] != 0) {
    CAN_Rx_GO(_I);   //CRx MOb
    _I++; 
    if (_I >= 8) _I = 0; //MAX 07
  } else {
    _I = 0; //ID=0 then ZERO
  }
} //END

//--------------------------------
void CAN_Rx_loop_02MOb() {
  byte Tx_i = 0;
  static byte Mode_i = 0;
  CAN_Rx_GO(0);   //MOb = 0
  CAN_Rx_GO(1);   //MOb = 1
} //END

//===================================================================================
void CAN_Rx_GO(byte _No) {
  const byte ENMOB_bit[15] = {1, 2, 4, 8, 16, 32, 64, 128, 1, 2, 4, 8, 16, 32, 64};
  byte M = 0;
  //--- CANENMOb check ----------------------
  if (_No >= 8) {
    M = CANEN1 & ENMOB_bit[_No]; //ENMOB8-14
  } else {
    M = CANEN2 & ENMOB_bit[_No]; //ENMOB0-7
  }
  if (M == 0) { //ZERO 受信完了
    //--- 受信データ転送処理 -------------------
    M = _No << 4; //Page set
    M =  M & B11110000; //M=>AAAAx000
    CANPAGE =  M;  //MOb + INDEX set
    //--- Data Length Read --------------------------------------
    CAN_RxD[_No][8] = CANCDMOB & B00001111; //Get Rx data Length
    //--- Data Read ---------------------------------------------
    if (CAN_RxD[_No][8] != 0) { //ZERO の時は処理しない
      if (CAN_RxD[_No][8] <= 8) {
        for (byte j = 0; j < CAN_RxD[_No][8]; j++) {
          CAN_RxD[_No][j] = CANMSG;
        }
      }
    }
    //--- Recive Enable -------------------
    M = CANCDMOB | B10000000;  //Rx Enable
    CANCDMOB = M;
  }
}




//=====================================================================================
void CAN_Tx_loop_MOb_No08_14() {
  byte M = 0;
  byte _MOb_No = 14;  //CAN Tx MOb No.
  static byte Tx_i = 0;
  //static byte Mode_i = 0;
  unsigned int _Tx_CAN_ID = 0;
  //--- TX STBSY Check ------------------------------------
  _MOb_No = CTx_MOb_No[Tx_i];
  _Tx_CAN_ID  = CAN_Tx_ID_0[Tx_i];
  _CAN_TxD[0] = CAN_TxD[Tx_i][0];
  _CAN_TxD[1] = CAN_TxD[Tx_i][1];
  _CAN_TxD[2] = CAN_TxD[Tx_i][2];
  _CAN_TxD[3] = CAN_TxD[Tx_i][3];
  _CAN_TxD[4] = CAN_TxD[Tx_i][4];
  _CAN_TxD[5] = CAN_TxD[Tx_i][5];
  _CAN_TxD[6] = CAN_TxD[Tx_i][6];
  _CAN_TxD[7] = CAN_TxD[Tx_i][7];
  _CAN_TxD[8] = CAN_TxD[Tx_i][8];
  //--- Tx Data Set ------------------------------------------------------------
  CAN_TxData_SET_Auto_INDEX(_MOb_No, _Tx_CAN_ID, _CAN_TxD[8], & _CAN_TxD[0]);
  CAN_TxData_GO_Trig();
  //送信完了待ちはしない
  Tx_i++;
  CAN_Tx_OK_Flag = false;
  //----------------------------
  // ID=0 で送信完了
  if (CAN_Tx_ID_0[Tx_i] == 0) {
    CAN_Tx_OK_Flag = true;
    Tx_i = 0;
  }
  //----------------------------
  // TXi>=8 で強制的に送信停止
  if (Tx_i >= 8) {
    CAN_Tx_OK_Flag = true;
    Tx_i = 0;
  }
}

//--------------------------------------------------------------------------------
void CAN_TxData_SET_Auto_INDEX(byte _No, unsigned int _ID, byte _L, byte * _D) {
  byte L = 0;
  byte M = 0;
  //--- Page set -----------------------
  M = _No << 4;
  M = M & B11110000;  //M=>AAAA0III
  CANPAGE = M ; //AUTO incriment INDEX
  //--- Data set -----------------------
  for (byte i = 0; i < _L; i++) {
    CANMSG = _D[i]; //--- MSG set ---------
  }
  //--- ID set -------------------------
  // STD ID only
  M = _ID & B00000111;
  M = M << 5;
  CANIDT2 = M & B11100000;
  M = _ID >> 3;
  CANIDT1 = M;
  //--- Length -------------------------
  L = _L & B00001111;
  M = CANCDMOB & B10110000;
  M = M | L;  //Set Length
  //M = M | B01000000;  //Tx Enable
  //M = M | B10000000;  //Rx Enable
  //M = M | B11000000;  //Enable frame Buffer
  CANCDMOB = M;
}

//--------------------------------------------------------------------------------
void CAN_TxData_GO_Trig() {
  byte M = 0;
  //--- TXOK Clear -------------------------------
  CANSTMOB = CANSTMOB & B10111111;  //TXOK Clear
  //--- CAN Tx Enable ----------------------------
  M = CANCDMOB & B00111111;
  M = M | B01000000;  //Tx Enable
  //M = M | B10000000;  //Rx Enable
  //M = M | B11000000;  //Enable frame Buffer
  CANCDMOB = M;
}
