//------------------------------------------------------
#include <LiquidCrystal_I2C.h>      //I2C LCD ライブラリー
#include <Wire.h>                   //I2C ライブラリー
LiquidCrystal_I2C lcd(0x27, 20, 4); //I2C Serial LCD20x4

//--- Opening --------------------|0123456789_123456789|--
void  LCD_Opening_0_loop() {
  lcd.setCursor(0, 0);  lcd.print("CAN485 TEST Program ");
  lcd.setCursor(0, 1);  lcd.print("I2C LCD 400KHz      ");
  lcd.setCursor(0, 2);  lcd.print("USB SPP 1000000bps  ");
  lcd.setCursor(0, 3);  lcd.print("CQ  Tragi Sep. 2021 ");
}

//--- LCD Print TEST -------------------------------------
void  LCD_PrintTest_0_loop() {
  //lcd.clear();
  lcd.setCursor(0, 0);  lcd.print("--------------------");
  lcd.setCursor(0, 1);  lcd.print("--------------------");
  lcd.setCursor(0, 2);  lcd.print("--------------------");
  lcd.setCursor(0, 3);  lcd.print("--------------------");
}

//---------------------------------------
void  LCD_init_setUp() {
  lcd.init();           //LCD SetUP
  lcd.backlight();      //back Light ON
  //lcd.noBacklight();  //back Light OFF
  //--- I2C speed Up --------------------
  Wire.setClock(400000);//I2C Speed Up
}

//--- CG RAM set ----------------------------------------------------------------------------
void  LCD_CG_RAM_setUp() {
  const byte LCD_CG_RAM_D0[8] = {B00000, B00000, B00000, B00000, B00000, B00000, B00001, 0};
  const byte LCD_CG_RAM_D1[8] = {B00000, B00000, B00000, B00000, B00000, B00001, B00011, 0};
  const byte LCD_CG_RAM_D2[8] = {B00000, B00000, B00000, B00000, B00001, B00011, B00111, 0};
  const byte LCD_CG_RAM_D3[8] = {B00000, B00000, B00000, B00001, B00011, B00111, B01111, 0};
  const byte LCD_CG_RAM_D4[8] = {B00000, B00000, B00001, B00011, B00111, B01111, B11111, 0};
  const byte LCD_CG_RAM_D5[8] = {B00000, B00001, B00011, B00111, B01111, B11111, B11111, 0};
  const byte LCD_CG_RAM_D6[8] = {B00001, B00011, B00111, B01111, B11111, B11111, B11111, 0};
  const byte LCD_CG_RAM_D7[8] = {B00011, B00111, B01111, B11111, B11111, B11111, B11111, 0};
  lcd.createChar(0, LCD_CG_RAM_D0);
  lcd.createChar(1, LCD_CG_RAM_D1);
  lcd.createChar(2, LCD_CG_RAM_D2);
  lcd.createChar(3, LCD_CG_RAM_D3);
  lcd.createChar(4, LCD_CG_RAM_D4);
  lcd.createChar(5, LCD_CG_RAM_D5);
  lcd.createChar(6, LCD_CG_RAM_D6);
  lcd.createChar(7, LCD_CG_RAM_D7);
}



//
