//　LCD表示系プログラム
byte LCD_IND_Data[8] = {};
//-----------------------------------
void LCD_loop() {
  static byte mode_I = 0;
  static unsigned long TTTT = 0;
  static unsigned long UUUU = 0;
  static unsigned long VVVV = 0;
  switch (mode_I) {
    //-------------------------------
    case 0: //CG RAM set
      LCD_CG_RAM_setUp();
      mode_I++;
      break;
    //-------------------------------
    case 1: //LCD Print TEST
      LCD_PrintTest_0_loop();
      TTTT = millis();
      mode_I++;
      break;
    //-------------------------------
    case 2: //Delay
      UUUU = millis();
      if (UUUU - TTTT >= 1000) mode_I++;
      break;
    //-------------------------------
    case 3: //Opemimg
      LCD_Opening_0_loop();
      TTTT = millis();
      mode_I++;
      break;
    //-------------------------------
    case 4: //Delay
      UUUU = millis();
      if (UUUU - TTTT >= 5000) mode_I++;
      break;
    //-------------------------------
    case 5:
      lcd.clear();
      mode_I++;
      break;
    //-------------------------------
    default:
      LCD_sub_loop();
      break;
  }
}

//=================================================
void LCD_sub_loop() {
  switch (Node_select_No) {
    //----------------
    case 0:
      LCD_OutPut0();
      break;
    //----------------
    case 1:
    case 2:
    case 3:
      LCD_OutPut1();
      break;
    //----------------
    default:
      break;
  }
}

//------------------------------------------------
void LCD_OutPut1() {
  byte A = 0;
  byte B = 0;
  byte C = 0;
  byte D = 0;
  unsigned int AA = 0;
  unsigned int BB = 0;
  unsigned int CC = 0;
  unsigned int DD = 0;
  static int aa = 0;
  static int bb = 0;
  static int cc = 0;
  static int dd = 0;
  static byte D0 = 0;
  static byte D1 = 0;
  static byte D2 = 0;
  static byte D3 = 0;
  static byte LCD_I = 0;  //0~ for switch case
  static byte LCD_C = 0;  //0-3 for LCD Line select
  static byte LCD_D = 0;  //0-7 for CAN data select

  switch (LCD_I) {
    //---------------------------------------------
    case 0:
      lcd.setCursor(0, LCD_C);  //LCD_C <= 0,1,2,3
      aa = CAN_Rx_ID_0[LCD_C];
      //aa = aa / 4;
      bb = aa % 16;  D0 = bb; aa = aa / 16;
      bb = aa % 16;  D1 = bb; aa = aa / 16;
      D2 = aa;
      LCD_I++;
      break;
    //---------------------------------------------
    case 1:
      lcd.print(D2, HEX);
      LCD_I++;
      break;
    //---------------------------------------------
    case 2:
      lcd.print(D1, HEX);
      LCD_I++;
      break;
    //---------------------------------------------
    case 3:
      lcd.print(D0, HEX);
      LCD_I++;
      break;
    //---------------------------------------------
    case 4:
      lcd.print(":");
      LCD_I++;
      break;
    //---------------------------------------------
    case 5:
    case 6:
      LCD_I++;
      break;
    //---------------------------------------------
    case 7:
      LCD_I++;
      break;
    //---------------------------------------------
    case 8:
      D1 = CAN_RxD[LCD_C][LCD_D] / 16;
      if (LCD_D < CAN_RxD[LCD_C][8]) {
        lcd.print(D1, HEX);
      } else {
        lcd.print("-");
      }
      LCD_I++;
      break;
    //---------------------------------------------
    case 9:
      D0 = CAN_RxD[LCD_C][LCD_D] % 16;
      if (LCD_D < CAN_RxD[LCD_C][8]) {
        lcd.print(D0, HEX);
      } else {
        lcd.print("-");
      }
      LCD_D++;
      if (LCD_D < 8) {
        LCD_I--;
      } else {
        LCD_D = 0;
        LCD_I++;
      }
      break;
    //---------------------------------------------
    case 10:
      LCD_I++;
      break;
    //---------------------------------------------
    case 11:
      LCD_I++;
      break;
    //---------------------------------------------
    case 12:
      LCD_I++;
      break;
    //---------------------------------------------
    case 13:
      LCD_I++;
      break;
    //---------------------------------------------
    case 14:
      LCD_I++;
      break;
    //---------------------------------------------
    case 15:
      LCD_C++;
      LCD_C = LCD_C & B00000011;
      LCD_I = 0;
      break;
    //-----------
    default:
      LCD_I = 0;
      break;
  }
}

//------------------------------------------------
void LCD_OutPut0() {
  byte A = 0;
  byte B = 0;
  byte C = 0;
  byte D = 0;
  unsigned int AA = 0;
  unsigned int BB = 0;
  unsigned int CC = 0;
  unsigned int DD = 0;
  static int aa = 0;
  static int bb = 0;
  static int cc = 0;
  static int dd = 0;
  static byte D0 = 0;
  static byte D1 = 0;
  static byte D2 = 0;
  static byte D3 = 0;
  static byte LCD_I = 0;
  static byte LCD_C = 0;

  switch (LCD_I) {
    //---------------------------------------------
    case 0:
      lcd.setCursor(0, LCD_C);  //LCD_C <= 0,1,2,3
      aa = AN_val[LCD_C];
      //aa = aa / 4;
      bb = aa % 10;  D0 = bb; aa = aa / 10;
      bb = aa % 10;  D1 = bb; aa = aa / 10;
      bb = aa % 10;  D2 = bb; aa = aa / 10;
      D3 = aa;
      LCD_I++;
      break;
    //---------------------------------------------
    case 1:
      lcd.print(D3);
      LCD_I++;
      break;
    //---------------------------------------------
    case 2:
      lcd.print(D2);
      LCD_I++;
      break;
    //---------------------------------------------
    case 3:
      lcd.print(D1);
      LCD_I++;
      break;
    //---------------------------------------------
    case 4:
      lcd.print(D0);
      LCD_I++;
      break;
    //---------------------------------------------
    case 5:
      lcd.print(" ");
      LCD_I++;
      break;
    //---------------------------------------------
    case 6:
    case 7:
      LCD_I++;
      break;
    //---------------------------------------------
    case 8:
      lcd.setCursor(5, LCD_C);  //LCD_C <= 0,1,2,3
      aa = A2_val[LCD_C];
      //aa = aa / 4;
      bb = aa % 10;  D0 = bb; aa = aa / 10;
      bb = aa % 10;  D1 = bb; aa = aa / 10;
      bb = aa % 10;  D2 = bb; aa = aa / 10;
      D3 = aa;
      LCD_I++;
      break;
    //---------------------------------------------
    case 9:
      lcd.print(D3);
      LCD_I++;
      break;
    //---------------------------------------------
    case 10:
      lcd.print(D2);
      LCD_I++;
      break;
    //---------------------------------------------
    case 11:
      lcd.print(D1);
      LCD_I++;
      break;
    //---------------------------------------------
    case 12:
      lcd.print(D0);
      LCD_I++;
      break;
    //---------------------------------------------
    case 13:
    case 14:
    case 15:
      LCD_I++;
      break;
    //---------------------------------------------
    case 16:
      lcd.setCursor(9, LCD_C);  //LCD_C <= 0,1,2,3
      LCD_I++;
      break;
    //---------------------------------------------
    case 17:
      aa = A2_val[LCD_C];
      bb = aa / 500;
      cc = constrain(bb, 0, 8);
      if (cc <= 6) {
        lcd.print(" ");
      } else {
        dd = cc - 7;
        lcd.write(byte(dd));
      }
      //
      LCD_I++;
      break;
    //---------------------------------------------
    case 18:
      if (cc <= 0) {
        lcd.print(" ");
      } else {
        lcd.write(byte(cc - 1));
      }
      //
      LCD_I++;
      break;
    //---------------------------------------------
    case 19:
      lcd.setCursor(11, LCD_C);  //LCD_C <= 0,1,2,3
      aa = Servo_val[LCD_C];
      bb = aa % 10;  D0 = bb; aa = aa / 10;
      bb = aa % 10;  D1 = bb; aa = aa / 10;
      bb = aa % 10;  D2 = bb; aa = aa / 10;
      D3 = aa;
      LCD_I++;
      break;
    //---------------------------------------------
    case 20:
      lcd.print(D3);
      LCD_I++;
      break;
    //---------------------------------------------
    case 21:
      lcd.print(D2);
      LCD_I++;
      break;
    //---------------------------------------------
    case 22:
      lcd.print(D1);
      LCD_I++;
      break;
    //---------------------------------------------
    case 23:
      lcd.print(D0);
      LCD_I++;
      break;
    //---------------------------------------------
    case 24:
      if (SW_flag[LCD_C] == true) {
        lcd.print("H");
      } else {
        lcd.print("L");
      }
      LCD_I++;
      break;
    //---------------------------------------------
    case 25:
      lcd.print(" ");
      LCD_I++;
      break;
    //---------------------------------------------
    case 26:
    case 27:
    case 28:
    case 29:
      LCD_I++;
      break;
    //---------------------------------------------
    case 30:
      LCD_C++;
      LCD_C = LCD_C & B00000011;
      LCD_I = 0;
      break;
    //-----------
    default:
      LCD_I = 0;
      break;
  }
}






//
